/*-----------------------------------------------------*/
/*--	Micro-EMPIX CORE  (Micro.h)                   -*/
/*--    Ver 1.0 (c) 2004                              -*/
/*--	E             -*/
/*--    ==================================            -*/
/*--    .                  -*/
/*--    .                        -*/
/*--    . .                      -*/
/*-----------------------------------------------------*/

/* ====================================================*/
/* ==========GLOBAL DEFINITIONS FOR OS FEATURES =======*/
/* ====================================================*/


#define NULL 0

/* ====================================================*/
/* ==========INTERNAL DEFINITIONS FOR PROCESSES =======*/
/* ====================================================*/


#define KERNEL_CHAR char
#define USER_INT int
#define KERNEL_PROCESS 0
#define USER_PROCESS 1
#define RESCHEDULE_DUE_TO_CLOCK 0
#define RESCHEDULE_DUE_TO_FCALL 1

#define KERNEL_INT int
#define KERNEL_VOID void
#define KERNEL_CHAR char

/* ====================================================*/
/* ==========   DEFINITIONS RELATED TO I/O ============*/
/* ====================================================*/



/* For chars_bef_irq */
#define ch1 0x00
#define ch4 0x40
#define ch8 0x80
#define ch14 0xC0

/* for IR_Byte: For example: Enable interrupts for reading and writing for every incoming/outgoing char: */
/* struct IrqConf *x = malloc(sizeof(struct IrqConf)); */
/* x->IR_Byte = IRQ_When_Char_Ready | IRQ_When_THR_Empty; */
/* x->Chars_Bef_Irq = ch1; */
#define IRQ_When_Char_Ready 0x1
#define IRQ_When_THR_Empty 0x2










/* Serial port functions (ORIGINAL)*/
/* Set HWDFlowControl to anything besides 0 to activate hardware flow control (NOT IMPLEMENTED YET) */
KERNEL_VOID SER_InitializePort(SER_PORT portnum, BAUD_RATE brate, const unsigned char HWDFlowControl, struct IrqConf *actions);
KERNEL_INT SER_ReadChar(SER_PORT portnum, char *ReadCh);
KERNEL_INT SER_WriteChar(SER_PORT portnum, char WriteCh);
KERNEL_VOID RestoreInterrupts(void);
/* Returns the cause of the interrupt (used only inside interrupt handlers) */
/* Returns 0 if the specified port hasn't triggered the interrupt */
/* Returns 1 if new char is available */
/* Returns 2 if a new char can be sent (THR Empty) */
/* Returns 3 if line status has changed */
/* Returns -1 if a transmission error occured */
KERNEL_INT InterruptReason(SER_PORT port);

/*************************************************************************************/
/*                                                                                   */
/*                              2nd Set                                              */
/*                              Simplified Functions (By default interrupt driven)   */
/*                                                                                   */
/*************************************************************************************/

/* Error_Type: */
/* 0 No error */
/* 1 Read error */
/* 3 Read driver internal buffer full. Char discarded */
/* 2 Write error */
struct QSR_ERROR
{
	unsigned char Error_Type;
	int Error;
};

KERNEL_VOID QSR_InitializePort(SER_PORT portnum, BAUD_RATE brate);

KERNEL_CHAR QSR_ReadChar(SER_PORT portnum);
KERNEL_INT QSR_WriteChar(SER_PORT portnum, char ch);

KERNEL_VOID QSR_FinalizePorts(void);


